"""
DO NOT EDIT THIS FILE!!
This file is automatically generated by the process_schemas.py program
in the scripts directory. It is not intended to be edited directly. If
you need to update the GEL protocol classes, please run the script
on the appropriate schema version.
"""
from protocols.protocol import (
    ProtocolElement,
    avro_parse,
    load_schema,
)


class Cohort(ProtocolElement):
    """
    No documentation
    """

    # load schema from file
    _schemaSource = load_schema(__file__)
    # parse into avro classes
    schema = avro_parse(_schemaSource)

    requiredFields = {
        "id",
        "sampleSetType",
    }

    @classmethod
    def getEmbeddedTypes(cls):
        return {}

    @classmethod
    def getEmbeddedEnums(cls):
        # import here to prevent circular imports in python 2.7.
        from protocols.protocol_7_6 import opencb as opencb_1_3_0

        return {
            "sampleSetType": opencb_1_3_0.SampleSetType,
        }

    @classmethod
    def getEmbeddedByNamespace(cls):
        # import here to prevent circular imports in python 2.7.
        from protocols.protocol_7_6 import opencb as opencb_1_3_0

        return {
            "org.opencb.biodata.models.metadata.SampleSetType": opencb_1_3_0.SampleSetType,
            "org.opencb.biodata.models.metadata.Cohort": opencb_1_3_0.Cohort,
        }

    __slots__ = [
        "id",
        "sampleSetType",
        "sampleIds",
    ]

    def __init__(
        self,
        id,
        sampleSetType,
        sampleIds=list,
        validate=None,
        **kwargs
    ):
        """Initialise the opencb_1_3_0.Cohort model.

        :param id:
        :type id: str
        :param sampleSetType:
        :type sampleSetType: SampleSetType
        :param sampleIds:
        :type sampleIds: list[str]
        """

        attributes = {k: v for k, v in locals().items() if k not in ["self", "unknown"]}
        ProtocolElement.__init__(self, **attributes)

    @classmethod
    def _namespace_version(cls):
        return "1.3.0"
